/*
##############################################################
   JEDNOTKA SERVOMOTORU
##############################################################   
   
   (c) Ivo Strasil 2007
   Upravy 2011
   www.strasil.net
   ivo@strasil.net
   
   Tento zdrojovy kod ani s jeho pomoci vytvoreni program 
   NENI volne siritelnym!
##############################################################

*/


#include <inttypes.h>
#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/interrupt.h>

#include "delay.h"
#include "a2d.h"

#define SYSCLK 4


#define HYSTEREZE	5

#define BLUELED_ON()	 PORTD|=0x10;
#define BLUELED_OFF() PORTD&=~0x10;	
#define YELED_ON()	 PORTD|=0x02;
#define YELED_OFF()	 PORTD&=~0x02;
#define GRLED_ON()	 PORTD|=0x04;
#define GRLED_OFF()	 PORTD&=~0x04;

#define POLOHOVAREG	(PIND&(1<<3))

int main(void) {
 //INICIALIZACE
 //porty

 wdt_enable(WDTO_1S);

 
 DDRC=0x00;
 PORTC=0x18;
 
 DDRD=0xF6	;
 PORTD=0x1F;
 
 DDRB=0xFE;
 PORTB=0xFF;
  
 //dame 250ms na ustaleni napeti...
 

 BLUELED_OFF();
 GRLED_OFF();
 YELED_OFF();
 
 wdt_reset();
 DelayMs(100); 
 BLUELED_ON();
 wdt_reset();
 DelayMs(100); 
 GRLED_ON();
 wdt_reset();
 DelayMs(100); 
 YELED_ON();
 wdt_reset();
 DelayMs(100); 
 
 BLUELED_OFF();
 GRLED_OFF();
 YELED_OFF();
 

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 62,500 kHz
// Mode: Fast PWM top=00FFh
// OC1A output: Non-Inv.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x81;
TCCR1B=0x0C;
TCNT1H=0x00;
TCNT1L=0x00;
OCR1A=0xFF;

 //normalni provoz>>>
 //vstupy:
 
//#define	iSTARTPOS	(!(PIND&8)) 
#define	iPULSY		(!(PIND&1))
 

 //vystupy:
#define	oA 	64
#define oB	32
#define STOP	128

	//SW dorazy

 unsigned short minpos=500, maxpos=524;;

	//gain
 unsigned short gain = 500;

 	//minpwr
 unsigned short minpwr = 500;

 	//hystereze
 unsigned short hyster = 500;

 unsigned char aktsmer=0;
 
 //nastaveni proudu motorem
 
 // Timer/Counter 2 initialization
 // Clock source: System Clock
 // Clock value: 62,500 kHz
 // Mode: Phase correct PWM top=FFh
 // OC2A output: Non-Inverted PWM
 // OC2B output: Disconnected
 ASSR=0x00;
 TCCR2A=0x81;
 TCCR2B=0x04;
 TCNT2=0x00;
 OCR2A=0xF9;
 OCR2B=0x00;
 
 a2dInit();
 
 
 
 while (1) {

 	wdt_reset();


	// AD konverze potenciometru min, max, null
	a2dSetChannel(0);
	DelayUs(100);
	a2dStartConvert();
	while (!(ADCSR&(1<<ADIF))) { asm("nop");};
	minpos = a2dConvert10bit();
	if (minpos<24) minpos = 24;
	
	a2dSetChannel(1);
	DelayUs(100);
	a2dStartConvert();
	while (!(ADCSR&(1<<ADIF))) { asm("nop");};
	maxpos = a2dConvert10bit();
	if (maxpos>1000) maxpos = 1000;
	
	a2dSetChannel(2);
	DelayUs(100);
	a2dStartConvert();
	while (!(ADCSR&(1<<ADIF))) { asm("nop");};
	gain = a2dConvert10bit();
 
	a2dSetChannel(3);
	DelayUs(100);
	a2dStartConvert();
	while (!(ADCSR&(1<<ADIF))) { asm("nop");};
	minpwr = a2dConvert10bit();
 
	a2dSetChannel(4);
	DelayUs(100);
	a2dStartConvert();
	while (!(ADCSR&(1<<ADIF))) { asm("nop");};
	hyster = a2dConvert10bit();
 
 
	// kontrola chybneho nastaveni ovl. prvku
	
	if (minpos+50>maxpos) {
		//chybne nastaveni prvku
		//vypni pohon
		
		PORTD&=~STOP;
		aktsmer = 0;
			
		//trvaly svit zlute
		GRLED_ON();
		YELED_ON();
		BLUELED_OFF();	
		continue;
	}
 
	// AD konverze skutecneho stavu
	unsigned short aktpol = 0;
	a2dSetChannel(5);
	DelayUs(100);
	a2dStartConvert();
	while (!(ADCSR&(1<<ADIF))) { asm("nop");};
	aktpol = a2dConvert10bit();
	
	if (aktpol<24 || aktpol>1000) {
		//doraz potenciometru
		//vypni pohon
		
		PORTD&=~STOP;
		aktsmer = 0;
			
		//modra + zluta + zelena
		GRLED_ON();
		YELED_ON();
		BLUELED_ON();		
		continue;
	}
 
	unsigned long tmp;
	
	//meze pohybu
	if (aktpol<minpos) {aktpol = minpos;};
	if (aktpol>maxpos) {aktpol = maxpos;};

	//urceni promile polohy
	unsigned short prompol = (unsigned long)1000 * (unsigned long)(aktpol - minpos) / (unsigned long)(maxpos - minpos);
	if (prompol>1000) prompol = 1000;
	
	//urceni casti nad/pod nul. bodem
	
	// odecet sirky impulsu resp. neexistence pulsu na pulsnim vstupu
	volatile unsigned long sirkaL=0;
	volatile unsigned long sirkaH=0;	

	unsigned char hystDolu = 0;
	unsigned char hystNahoru = 0;
	
	while (iPULSY && sirkaH++ < 6000) {asm("nop");}
	if (sirkaH<6000) {
	sirkaH=0;	}
	while (!iPULSY && sirkaL++ < 9000) {DelayUs(1);}
	while (iPULSY && sirkaH++ < 6000) {asm("nop");}
	
	// sepnuti motoru podle pozadavku
	if (sirkaL < 5000 && sirkaH < 1300) {
		//mame OK pulsy, kontrola pomeru sirek
				
		
		if (sirkaH>100 && sirkaH<1100) {
			if (sirkaH>900) sirkaH = 900;
			if (sirkaH<560) sirkaH = 560;

			unsigned int polPromile = 100 * (sirkaH - 560) / (90 - 56);

			//mame OK pulsy
			
			GRLED_ON();
			YELED_OFF();
			BLUELED_OFF();

			aktsmer = 0;

#define MIN(X,Y) ((X) < (Y) ?  (X) : (Y))

			unsigned char OCR1Atmp = 128;


				


			if (POLOHOVAREG) {

				//regulacni smycka - POLOHOVA REGULACE
				unsigned long regDelta;

				if (polPromile < prompol) {
					regDelta = prompol- polPromile;
					regDelta = (unsigned long)regDelta * gain;
					regDelta = regDelta >> 8;
					if (regDelta > 499) regDelta = 499;
					polPromile = 500 - regDelta;
				} else {
					regDelta = polPromile- prompol;
					regDelta = (unsigned long)regDelta * gain;
					regDelta = regDelta >> 8;
					if (regDelta > 499) regDelta = 499;
					polPromile = 500 + regDelta;
				}

				if (regDelta < 80) {
					BLUELED_ON();
				} else {
				
				}

				unsigned short hkoef = 10 + hyster/20;

				if (polPromile>500+hkoef) hystNahoru = 1;
				if (polPromile<=500) hystNahoru = 0;


				if (polPromile<500-hkoef) hystDolu = 1;
				if (polPromile>=500) hystDolu = 0;

				if (hystDolu) {			
					aktsmer = oA;
					OCR1Atmp=MIN(255 ,regDelta*3);
				}
			
				if (hystNahoru) {			
					aktsmer = oB;
					OCR1Atmp=MIN(255 ,regDelta*3);
				}
				
			} else {
				//regulacni smycka - RYCHLOSTNI REGULACE
	
				if (polPromile<400) {
					aktsmer = oA;
					OCR1Atmp=MIN(255 ,2*(400-polPromile)/3);
				}
			
				if (polPromile>600) {
					aktsmer = oB;
					OCR1Atmp=MIN(255 ,2*(polPromile-600)/3);
				}
			}


			//vyhodnoceni dorazu - plynule zpomaleni

			if (prompol>900 && aktsmer == oB) {
				YELED_ON();
				OCR1Atmp = MIN(OCR1Atmp,(1000-prompol)*3);
			}

			if (prompol<100 && aktsmer == oA) {
				YELED_ON();
				OCR1Atmp = MIN(OCR1Atmp,(prompol)*3);
			}

			//vyhodnoceni dorazu - zastaveni, zhasnuti "RUN" LED
			
			if (aktpol>=maxpos && aktsmer == oB) {
				YELED_ON();
				GRLED_OFF();
				aktsmer = 0;
			}

			if (aktpol<=minpos && aktsmer == oA) {
				YELED_ON();
				GRLED_OFF();
				aktsmer = 0;
			}


			unsigned short pooc = (minpwr >> 2) + ((unsigned long)((unsigned long)OCR1Atmp*(256-(minpwr>>2)))>>8);
			if (pooc>255) pooc = 255;

			OCR1A = pooc;


			//aktsmer=0;
			//vyhodnoceni polohy
	/*		if (aktpol<(pomer - HYSTEREZE)) {
				aktsmer = oA;
			}
			if (aktpol>=pomer && aktsmer == oA) {
				aktsmer = 0;
			}
			if (aktpol>(pomer + HYSTEREZE)) {
				aktsmer = oB;
			}
			if (aktpol<=pomer && aktsmer == oB) {
				aktsmer = 0;
			}
				*/	
			
			PORTD|=STOP; //zapnuti napajeni pohonu
			
			if (aktsmer && !POLOHOVAREG) {
				BLUELED_ON();
			} else {
				
			}
			
			//prepnuti smeru podle aktsmer
			/*PORTD&=~oA;
			PORTD&=~oB;*/
			PORTD=(PORTD&~(oA|oB)) | aktsmer;
		
			
		} else {
			//chyba pulsu!
			PORTD&=~STOP;
			aktsmer = 0;
			
			GRLED_ON();
			YELED_ON();
			BLUELED_OFF();
		}		
	} else {
		//nemame pulsy!
		PORTD&=~STOP;
		aktsmer = 0;
		
		GRLED_ON();
		YELED_ON();
		BLUELED_OFF();
	}
	
	
	
 
	
 }; 
}
